Package uk.ac.starlink.table.join

# Class CuboidCartesianMatchEngine

java.lang.Object
uk.ac.starlink.table.join.AbstractCartesianMatchEngine
uk.ac.starlink.table.join.CuboidCartesianMatchEngine

All Implemented Interfaces:
  `MatchEngine`

public class CuboidCartesianMatchEngine extends AbstractCartesianMatchEngine
Matchers which matches within a cuboidal shape in a Cartesian space. This differs from most of the other N-dimensional match engines which use an ellipsoid of some sort. It may be useful for identifying associations with pixels etc. Tuples are just N-element position coordinate vectors.

Since:
  10 Feb 2014
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`CuboidCartesianMatchEngine(double[] errs)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`double`
`getError(int idim)`
Returns the matching error in a given dimension.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method.
`double`
`getScoreScale()`
Returns a scale value for the match score.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`void`
`setError(int idim, double err)`
Sets the matching error in a given dimension.
`protected void`
`setScale(int idim, double err)`
Sets the scale value for a given dimension.
`String`
`toString()`

### Methods inherited from class uk.ac.starlink.table.join.AbstractCartesianMatchEngine

`getBinFactor, getIsotropicScale, getNdim, getScale, getTuningParameters, setBinFactor, setIsotropicScale`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### CuboidCartesianMatchEngine

public CuboidCartesianMatchEngine(double[] errs)
Constructor. The initial values of the ellipse principal axis lengths are specified here; the dimensionality of the space is defined by the length of this array.

Parameters:
  `errs` - initial axis lengths of the error ellipse

## Method Details

### setError

public void setError(int idim, double err)
Sets the matching error in a given dimension.

Parameters:
  `idim` - dimension index
  `err` - axis length of error ellipse in dimension `idim`

### getError

public double getError(int idim)
Returns the matching error in a given dimension.

Parameters:
  `idim` - dimension index
Returns:
  axis length of error ellipse in dimension `idim`

### setScale

protected void setScale(int idim, double err)
Description copied from class: `AbstractCartesianMatchEngine`
Sets the scale value for a given dimension. In conjunction with the bin factor, this determines the bin size.

Overrides:
  `setScale` in class `AbstractCartesianMatchEngine`
Parameters:
  `idim` - dimension index
  `err` - guide error distance in dimension `idim`

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Returns:
  array of described values which influence the match

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Returns:
  metadata for the match score results

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Description copied from interface: `MatchEngine`
Returns a scale value for the match score. The intention is that the result of `matchScore`/`MatchEngine.getScoreScale()` is of order unity, and is thus comparable between different match engines.

As a general rule, the result should be the maximum value ever returned from the `matchScore` method, corresponding to the least good successful match. For binary MatchEngine implementations (all matches are either score=0 or failures) a value of 1 is recommended. If nothing reliable can be said about the scale, NaN may be returned.

Returns:
  scale of successful match scores, a positive finite number or NaN

### toString

public String toString()

Specified by:
  `toString` in class `AbstractCartesianMatchEngine`